Index: LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 4046)
@@ -25,5 +25,6 @@
 
     USE dimphy, ONLY: klon, klev, klevp1
-    USE infotrac_phy, ONLY: nbtr
+    USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niadv
+    USE strings_mod,  ONLY: maxlen
     USE mod_phys_lmdz_para, ONLY: is_north_pole_phy,is_south_pole_phy
     USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
@@ -366,5 +367,4 @@
     USE pbl_surface_mod, ONLY: snow
     USE indice_sol_mod, ONLY: nbsrf
-    USE infotrac_phy, ONLY: nqtot, nqo, type_trac, tname, niadv
     USE geometry_mod, ONLY: cell_area, latitude_deg, longitude_deg
     USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, landice_opt
@@ -441,5 +441,5 @@
     INTEGER ISW
     CHARACTER*1 ch1
-    CHARACTER*20 varname
+    CHARACTER(LEN=maxlen) :: varname, dn
 
 #ifdef CPP_XIOS
@@ -454,4 +454,5 @@
 
     INTEGER :: nqup
+
 
     ! On calcul le nouveau tau:
@@ -512,47 +513,52 @@
           DO iq=nqo+1, nqtot
             iiq=niadv(iq)
-            varname=trim(tname(iiq))
-            WRITE (lunout,*) 'XIOS var=', nqo, iq, nqtot, varname
+            dn = 'd'//TRIM(tracers(iiq)%name)//'_'
+            WRITE (lunout,*) 'XIOS var=', nqo, iq, nqtot, tracers(iiq)%name
+
+            unt = "kg kg-1"
+            varname=trim(tracers(iiq)%name)
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1")
-            varname='d'//trim(tname(iiq))//'_vdf'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+
+            unt = "kg kg-1 s-1"
+            varname=TRIM(dn)//'vdf'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_the'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'the'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_con'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'con'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_lessi_impa'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'lessi_impa'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_lessi_nucl'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'lessi_nucl'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_insc'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'insc'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_bcscav'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'bcscav'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_evapls'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'evapls'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_ls'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'ls'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_trsp'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'trsp'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_sscav'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'sscav'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_sat'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'sat'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
-            varname='d'//trim(tname(iiq))//'_uscav'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+            varname=TRIM(dn)//'uscav'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg kg-1 s-1")
+            CALL xios_set_attr(child, name=varname, unit=unt)
           ENDDO
           !On ajoute les variables 2D traceurs par l interface fortran 
@@ -561,11 +567,15 @@
           DO iq=nqo+1, nqtot
             iiq=niadv(iq)
-            varname='cum'//trim(tname(iiq))
+
+            unt = "kg m-2"
+            varname='cum'//trim(tracers(iiq)%name)
             WRITE (lunout,*) 'XIOS var=', iq, nqtot, varname
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg m-2")
-            varname='cumd'//trim(tname(iiq))//'_dry'
+            CALL xios_set_attr(child, name=varname, unit=unt)
+
+            unt = "kg m-2 s-1"
+            varname='cumd'//trim(tracers(iiq)%name)//'_dry'
             CALL xios_add_child(group_handle, child, varname)
-            CALL xios_set_attr(child, name=varname, unit="kg m-2 s-1")
+            CALL xios_set_attr(child, name=varname, unit=unt)
           ENDDO
     ENDIF
@@ -573,4 +583,5 @@
 #endif
 #endif
+
     ! ug la boucle qui suit ne sert qu'une fois, pour l'initialisation, sinon il n'y a toujours qu'un seul passage:
     DO iinit=1, iinitend
@@ -600,5 +611,4 @@
        ENDIf
        CALL histwrite_phy(o_aire, zx_tmp_fi2d)
-
        IF (vars_defined) THEN
           DO i=1, klon
Index: LMDZ6/trunk/libf/phylmd/traclmdz_mod.F90
===================================================================
--- LMDZ6/trunk/libf/phylmd/traclmdz_mod.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmd/traclmdz_mod.F90	(revision 4046)
@@ -96,4 +96,5 @@
     USE indice_sol_mod
     USE print_control_mod, ONLY: lunout
+    USE strings_mod, ONLY: strLower
 
 ! Input variables
@@ -175,95 +176,69 @@
 !!       iiq=niadv(it+2)                                                            ! jyg
        iiq=niadv(it+nqo)                                                            ! jyg
-       IF ( tname(iiq) == "RN" ) THEN                                               
-          id_rn=it ! radon
-       ELSE IF ( tname(iiq) == "PB") THEN
-          id_pb=it ! plomb
-! RomP >>> profil initial de PB210 
-     open (ilesfil2,file='prof.pb210',status='old',iostat=irr2)
-     IF (irr2 == 0) THEN 
-      read(ilesfil2,*) kradio2
-      print*,'number of levels for pb210 profile ',kradio2
-      do k=kradio2,1,-1
-       read (ilesfil2,*) plomb(:,k)
-      enddo
-      close(ilesfil2)
-      do k=1,klev
-       do i=1,klon
-         tr_seri(i,k,id_pb)=plomb(i,k)
-!!        print*, 'tr_seri',i,k,tr_seri(i,k,id_pb)
-        enddo
-      enddo
-     ELSE
-       print *, 'Prof.pb210 does not exist: use restart values'
-     ENDIF
-! RomP <<<
-       ELSE IF ( tname(iiq) == "Aga" .OR. tname(iiq) == "AGA" ) THEN
-          ! Age of stratospheric air
-          id_aga=it
-          radio(id_aga) = .FALSE.
-          aerosol(id_aga) = .FALSE.
-          pbl_flg(id_aga) = 0 
-          
-          ! Find the first model layer above 1.5km from the surface
-          IF (klev>=30) THEN
-             lev_1p5km=6   ! NB! This value is for klev=39
-          ELSE IF (klev>=10) THEN
-             lev_1p5km=5   ! NB! This value is for klev=19
-          ELSE
-             lev_1p5km=klev/2
-          END IF
-       ELSE IF ( tname(iiq) == "BE" .OR. tname(iiq) == "Be" .OR.  &
-            tname(iiq) == "BE7" .OR. tname(iiq) == "Be7" ) THEN  
-          ! Recherche du Beryllium 7
-          id_be=it
-          ALLOCATE( srcbe(klon,klev) )
-          radio(id_be) = .TRUE.
-          aerosol(id_be) = .TRUE. ! le Be est un aerosol
-!jyg le 13/03/2013 ; ajout de pplay en argument de init_be
-!!!          CALL init_be(pctsrf,masktr(:,id_be),tautr(id_be),vdeptr(id_be),scavtr(id_be),srcbe)
-          CALL init_be(pctsrf,pplay,masktr(:,id_be),tautr(id_be),vdeptr(id_be),scavtr(id_be),srcbe)
-          WRITE(lunout,*) 'Initialisation srcBe: OK'
-! RomP >>> profil initial de Be7
-      open (ilesfil,file='prof.be7',status='old',iostat=irr)
-      IF (irr == 0) THEN 
-       read(ilesfil,*) kradio
-       print*,'number of levels for Be7 profile ',kradio
-       do k=kradio,1,-1
-        read (ilesfil,*) beryllium(:,k)
-       enddo
-       close(ilesfil)
-       do k=1,klev
-         do i=1,klon
-          tr_seri(i,k,id_be)=beryllium(i,k)
-!!        print*, 'tr_seri',i,k,tr_seri(i,k,id_be)
-         enddo
-       enddo
-     ELSE
-       print *, 'Prof.Be7 does not exist: use restart values'
-     ENDIF
-! RomP <<<
-       ELSE IF (tname(iiq)=="O3" .OR. tname(iiq)=="o3") THEN
-          ! Recherche de l'ozone : parametrization de la chimie par Cariolle
-          id_o3=it
-          CALL alloc_coefoz   ! allocate ozone coefficients
-          CALL press_coefoz   ! read input pressure levels
-       ELSE IF ( tname(iiq) == "pcsat" .OR. tname(iiq) == "Pcsat" ) THEN
-          id_pcsat=it
-       ELSE IF ( tname(iiq) == "pcocsat" .OR. tname(iiq) == "Pcocsat" ) THEN
-          id_pcocsat=it
-       ELSE IF ( tname(iiq) == "pcq" .OR. tname(iiq) == "Pcq" ) THEN
-          id_pcq=it
-       ELSE IF ( tname(iiq) == "pcs0" .OR. tname(iiq) == "Pcs0" ) THEN
-          id_pcs0=it
-          conv_flg(it)=0 ! No transport by convection for this tracer
-       ELSE IF ( tname(iiq) == "pcos0" .OR. tname(iiq) == "Pcos0" ) THEN
-          id_pcos0=it
-          conv_flg(it)=0 ! No transport by convection for this tracer
-       ELSE IF ( tname(iiq) == "pcq0" .OR. tname(iiq) == "Pcq0" ) THEN
-          id_pcq0=it
-          conv_flg(it)=0 ! No transport by convection for this tracer
-       ELSE
-          WRITE(lunout,*) 'This is an unknown tracer in LMDZ : ', trim(tname(iiq))
-       END IF
+print*,'###'//TRIM(tracers(iiq)%name)//'###'
+print*,'###'//TRIM(strLower(tracers(iiq)%name))//'###'
+       SELECT CASE(strLower(tracers(iiq)%name))
+         CASE("rn");      id_rn     = it ! radon
+         CASE("pb");      id_pb     = it ! plomb
+         CASE("aga");     id_aga    = it ! Age of stratospheric air
+         CASE("be","be7");id_be     = it ! Recherche du Beryllium 7
+         CASE("o3");      id_o3     = it ! Recherche de l'ozone
+         CASE("pcsat");   id_pcsat  = it
+         CASE("pcocsat"); id_pcocsat= it
+         CASE("pcq");     id_pcq    = it
+         CASE("pcs0");    id_pcs0   = it
+         CASE("pcos0");   id_pcos0  = it
+         CASE("pcq0");    id_pcq0   = it
+         CASE DEFAULT
+           WRITE(lunout,*) 'This is an unknown tracer in LMDZ : ', trim(tracers(iiq)%name)
+       END SELECT
+
+       SELECT CASE(strLower(tracers(iiq)%name))
+         CASE("pb")                        !--- RomP >>> profil initial de PB210 
+           OPEN(ilesfil2,file='prof.pb210',status='old',iostat=irr2)
+           IF(irr2 == 0) THEN 
+             READ(ilesfil2,*) kradio2
+             WRITE(lunout,*)'number of levels for pb210 profile ',kradio2
+             DO k=kradio2,1,-1; READ (ilesfil2,*) plomb(:,k); END DO
+             CLOSE(ilesfil2)
+             tr_seri(:,:,id_pb) = plomb(:,:)
+           ELSE
+             WRITE(lunout,*)'Prof. Pb210 does not exist: use restart values'
+           END IF
+         CASE("aga")
+           radio(id_aga) = .FALSE.
+           aerosol(id_aga) = .FALSE.
+           pbl_flg(id_aga) = 0 
+           ! Find the first model layer above 1.5km from the surface
+           IF (klev>=30) THEN
+              lev_1p5km=6                  !--- NB: This value is for klev=39
+           ELSE IF (klev>=10) THEN
+              lev_1p5km=5                  !--- NB: This value is for klev=19
+           ELSE
+              lev_1p5km=klev/2
+           END IF
+         CASE("be","be7")
+           ALLOCATE( srcbe(klon,klev) )
+           radio(id_be) = .TRUE.
+           aerosol(id_be) = .TRUE.         !--- Le Be est un aerosol
+           CALL init_be(pctsrf,pplay,masktr(:,id_be),tautr(id_be),vdeptr(id_be),scavtr(id_be),srcbe)
+           WRITE(lunout,*) 'Initialisation srcBe: OK'
+                                           !--- RomP >>> profil initial de Be7
+           OPEN(ilesfil,file='prof.be7',status='old',iostat=irr)
+           IF(irr == 0) THEN
+             READ(ilesfil,*) kradio
+             WRITE(lunout,*)'number of levels for Be7 profile ',kradio
+             DO k=kradio,1,-1; READ(ilesfil,*) beryllium(:,k); END DO
+             CLOSE(ilesfil)
+             tr_seri(:,:,id_be)=beryllium(:,:)
+           ELSE
+             WRITE(lunout,*)'Prof. Be7 does not exist: use restart values'
+           END IF
+         CASE("o3")                         !--- Parametrisation par la chimie de Cariolle
+           CALL alloc_coefoz                !--- Allocate ozone coefficients
+           CALL press_coefoz                !--- Read input pressure levels
+         CASE("pcs0","pcos0","pcq0")
+           conv_flg(it)=0                   !--- No transport by convection for this tracer
+       END SELECT
     END DO
 
@@ -309,5 +284,5 @@
        IF (zero) THEN
           ! The tracer was not found in restart file or it was equal zero everywhere.
-          WRITE(lunout,*) "The tracer ",trim(tname(iiq))," will be initialized"
+          WRITE(lunout,*) "The tracer ",trim(tracers(iiq)%name)," will be initialized"
           IF (it==id_pcsat .OR. it==id_pcq .OR. &
                it==id_pcs0 .OR. it==id_pcq0) THEN
Index: LMDZ6/trunk/libf/phylmdiso/infotrac_phy.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/infotrac_phy.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmdiso/infotrac_phy.F90	(revision 4046)
@@ -7,4 +7,6 @@
 ! the dynamics (could be further cleaned) and is initialized using values
 ! provided by the dynamics
+
+  USE readTracFiles_mod, ONLY: trac_type, maxlen, delPhase
 
 ! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
@@ -41,12 +43,7 @@
 !$OMP THREADPRIVATE(nqperes)
 
-! Name variables
-  INTEGER,PARAMETER :: tname_lenmax=128 
-  CHARACTER(len=tname_lenmax), ALLOCATABLE, DIMENSION(:), SAVE :: tname ! tracer short name for restart and diagnostics
-  CHARACTER(len=tname_lenmax+3), ALLOCATABLE, DIMENSION(:), SAVE :: ttext ! tracer long name for diagnostics
-!$OMP THREADPRIVATE(tname,ttext)
-
-!! iadv  : index of trasport schema for each tracer
-!  INTEGER, ALLOCATABLE, DIMENSION(:), SAVE    :: iadv
+! Tracers parameters
+  TYPE(trac_type), TARGET, ALLOCATABLE, SAVE :: tracers(:)
+!$OMP THREADPRIVATE(tracers)
 
 ! niadv : vector keeping the coorspondance between all tracers(nqtot) treated in the 
@@ -107,5 +104,5 @@
 CONTAINS
 
-  SUBROUTINE init_infotrac_phy(nqtot_,nqo_,nbtr_,nqtottr_,nqCO2_,tname_,ttext_,type_trac_,&
+  SUBROUTINE init_infotrac_phy(nqtot_,nqo_,nbtr_,nqtottr_,nqCO2_,tracers_,type_trac_,&
                                niadv_,conv_flg_,pbl_flg_,solsym_,&
                                nqfils_,nqdesc_,nqdesc_tot_,iqfils_,iqpere_,&
@@ -139,6 +136,5 @@
     INTEGER,INTENT(IN) :: id_BIN01_strat_
 #endif
-    CHARACTER(len=*),INTENT(IN) :: tname_(nqtot_) ! tracer short name for restart and diagnostics
-    CHARACTER(len=*),INTENT(IN) :: ttext_(nqtot_) ! tracer long name for diagnostics
+    CHARACTER(len=*),INTENT(IN) :: tracers_(nqtot_) ! tracers descriptors
     CHARACTER(len=*),INTENT(IN) :: type_trac_
     INTEGER,INTENT(IN) :: niadv_ (nqtot_) ! equivalent dyn / physique
@@ -179,4 +175,5 @@
     nqCO2=nqCO2_
     nqtottr=nqtottr_
+    ALLOCATE(tracers(nqtot)); tracers(:) = tracers_(:)
 #ifdef CPP_StratAer
     nbtr_bin=nbtr_bin_
@@ -187,8 +184,4 @@
     id_BIN01_strat=id_BIN01_strat_
 #endif
-    ALLOCATE(tname(nqtot))
-    tname(:) = tname_(:)
-    ALLOCATE(ttext(nqtot))
-    ttext(:) = ttext_(:)
     type_trac = type_trac_
     ALLOCATE(niadv(nqtot))
Index: LMDZ6/trunk/libf/phylmdiso/phyetat0.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmdiso/phyetat0.F90	(revision 4046)
@@ -31,5 +31,5 @@
   USE geometry_mod, ONLY : longitude_deg, latitude_deg
   USE iostart, ONLY : close_startphy, get_field, get_var, open_startphy
-  USE infotrac_phy, only: nbtr, nqo, type_trac, tname, niadv, &
+  USE infotrac_phy, only: nbtr, nqo, type_trac, tracers, niadv, &
         itr_indice ! C Risi
   USE traclmdz_mod,    ONLY : traclmdz_from_restart
@@ -476,6 +476,6 @@
         iq=itr_indice(it)                                                    
         iiq=niadv(iq)                                                        ! jyg
-        found=phyetat0_get(1,trs(:,it),"trs_"//tname(iiq), &
-              "Surf trac"//tname(iiq),0.)
+        found=phyetat0_get(1,trs(:,it),"trs_"//TRIM(tracers(iiq)%name), &
+                                  "Surf trac"//TRIM(tracers(iiq)%name),0.)
      ENDDO
      CALL traclmdz_from_restart(trs)
@@ -489,5 +489,5 @@
         found=phyetat0_get(1,co2_send,"co2_send","co2 send",co2_ppm)
      ENDIF
-  ENDIF !IF (type_trac == 'lmdz') THEN
+  ENDIF
 
 #ifdef ISO
Index: LMDZ6/trunk/libf/phylmdiso/phyredem.F90
===================================================================
--- LMDZ6/trunk/libf/phylmdiso/phyredem.F90	(revision 4045)
+++ LMDZ6/trunk/libf/phylmdiso/phyredem.F90	(revision 4046)
@@ -38,5 +38,5 @@
   USE iostart, ONLY: open_restartphy, close_restartphy, enddef_restartphy, put_field, put_var
   USE traclmdz_mod, ONLY : traclmdz_to_restart
-  USE infotrac_phy, ONLY: type_trac, niadv, tname, nbtr, nqo,itr_indice
+  USE infotrac_phy, ONLY: type_trac, niadv, tracers, nbtr, nqo,itr_indice
 #ifdef ISO
   USE infotrac_phy, ONLY: itr_indice,niso,ntraciso
@@ -350,5 +350,5 @@
           iq=itr_indice(it)                                                           ! jyg
           iiq=niadv(iq)                                                           ! jyg
-          CALL put_field(pass,"trs_"//tname(iiq), "", trs(:, it))
+          CALL put_field(pass,"trs_"//tracers(iiq)%name, "", trs(:, it))
        END DO
        IF (carbon_cycle_cpl) THEN
@@ -407,6 +407,4 @@
     IF (pass==2) CALL close_restartphy
   ENDDO ! DO pass=1,2   ! pass=1 netcdf definition ; pass=2 netcdf write
-  
-
   
   !$OMP BARRIER
